Skip to main content
POST
/
responses
Create response
const options = {
  method: 'POST',
  headers: {Authorization: 'Bearer <token>', 'Content-Type': 'application/json'},
  body: JSON.stringify({
    model: 'openai/gpt-5-nano',
    stream: false,
    input: [{role: 'user', content: 'Give me the current datetime in Asia/Tokyo.'}],
    tools: [{type: 'gateway:datetime', parameters: {timezone: 'Asia/Tokyo'}}],
    tool_choice: 'auto'
  })
};

fetch('https://api.phaseo.ai/v1/responses', options)
  .then(res => res.json())
  .then(res => console.log(res))
  .catch(err => console.error(err));
import requests

url = "https://api.phaseo.ai/v1/responses"

payload = {
"model": "openai/gpt-5-nano",
"stream": False,
"input": [
{
"role": "user",
"content": "Give me the current datetime in Asia/Tokyo."
}
],
"tools": [
{
"type": "gateway:datetime",
"parameters": { "timezone": "Asia/Tokyo" }
}
],
"tool_choice": "auto"
}
headers = {
"Authorization": "Bearer <token>",
"Content-Type": "application/json"
}

response = requests.post(url, json=payload, headers=headers)

print(response.text)
curl --request POST \
--url https://api.phaseo.ai/v1/responses \
--header 'Authorization: Bearer <token>' \
--header 'Content-Type: application/json' \
--data '
{
"model": "openai/gpt-5-nano",
"stream": false,
"input": [
{
"role": "user",
"content": "Give me the current datetime in Asia/Tokyo."
}
],
"tools": [
{
"type": "gateway:datetime",
"parameters": {
"timezone": "Asia/Tokyo"
}
}
],
"tool_choice": "auto"
}
'
package main

import (
"fmt"
"strings"
"net/http"
"io"
)

func main() {

url := "https://api.phaseo.ai/v1/responses"

payload := strings.NewReader("{\n \"model\": \"openai/gpt-5-nano\",\n \"stream\": false,\n \"input\": [\n {\n \"role\": \"user\",\n \"content\": \"Give me the current datetime in Asia/Tokyo.\"\n }\n ],\n \"tools\": [\n {\n \"type\": \"gateway:datetime\",\n \"parameters\": {\n \"timezone\": \"Asia/Tokyo\"\n }\n }\n ],\n \"tool_choice\": \"auto\"\n}")

req, _ := http.NewRequest("POST", url, payload)

req.Header.Add("Authorization", "Bearer <token>")
req.Header.Add("Content-Type", "application/json")

res, _ := http.DefaultClient.Do(req)

defer res.Body.Close()
body, _ := io.ReadAll(res.Body)

fmt.Println(string(body))

}
HttpResponse<String> response = Unirest.post("https://api.phaseo.ai/v1/responses")
.header("Authorization", "Bearer <token>")
.header("Content-Type", "application/json")
.body("{\n \"model\": \"openai/gpt-5-nano\",\n \"stream\": false,\n \"input\": [\n {\n \"role\": \"user\",\n \"content\": \"Give me the current datetime in Asia/Tokyo.\"\n }\n ],\n \"tools\": [\n {\n \"type\": \"gateway:datetime\",\n \"parameters\": {\n \"timezone\": \"Asia/Tokyo\"\n }\n }\n ],\n \"tool_choice\": \"auto\"\n}")
.asString();


{
  "id": "<string>",
  "object": "<string>",
  "created": 123,
  "model": "<string>",
  "output": [
    {
      "type": "<string>",
      "role": "<string>",
      "content": [
        {
          "type": "output_text",
          "text": "<string>",
          "annotations": [
            {}
          ]
        }
      ],
      "call_id": "<string>",
      "name": "<string>",
      "arguments": "<string>"
    }
  ],
  "output_items": [
    {
      "type": "<string>",
      "role": "<string>",
      "content": [
        {
          "type": "output_text",
          "text": "<string>",
          "annotations": [
            {}
          ]
        }
      ],
      "call_id": "<string>",
      "name": "<string>",
      "arguments": "<string>"
    }
  ],
  "content": [
    {}
  ],
  "role": "<string>",
  "stop_reason": "<string>",
  "type": "<string>",
  "usage": {
    "prompt_tokens": 123,
    "completion_tokens": 123,
    "total_tokens": 123,
    "server_tool_use": {
      "datetime_requests": 1,
      "web_search_requests": 1,
      "web_fetch_requests": 1
    }
  }
}

Server tools

/v1/responses supports regular function tools and these gateway-managed server tools:
  • gateway:datetime
  • phaseo:web_search
  • phaseo:web_fetch
  • phaseo:advisor
  • phaseo:image_generation
  • phaseo:apply_patch

Datetime example

curl https://api.phaseo.ai/v1/responses \
  -H "Authorization: Bearer YOUR_API_KEY" \
  -H "Content-Type: application/json" \
  -d '{
    "model": "openai/gpt-5-nano",
    "stream": false,
    "input": [
      { "role": "user", "content": "Give me the current datetime in Asia/Tokyo." }
    ],
    "tools": [
      {
        "type": "gateway:datetime",
        "parameters": { "timezone": "Asia/Tokyo" }
      }
    ],
    "tool_choice": "auto"
  }'
When a server tool is used, usage includes the matching usage.server_tool_use.* counters.
  • gateway:datetime -> datetime_requests
  • phaseo:web_search -> web_search_requests, web_search_results, web_search_extra_results
  • phaseo:web_fetch -> web_fetch_requests
  • phaseo:advisor -> advisor_requests
  • phaseo:image_generation -> image_generation_requests
  • phaseo:apply_patch -> apply_patch_requests

Streaming note

stream: true is also supported. For gateway-managed server tools, Phaseo may materialize the upstream tool-call turn and re-emit a synthetic stream after continuing the loop.

Authorizations

Authorization
string
header
required

Bearer token authentication

Body

application/json
model
string
required
input
required
background
boolean
include
string[]
instructions
string
max_output_tokens
integer
Required range: x >= 1
metadata
object
session_id
string

Unique identifier for grouping related requests (for example, a conversation or agent workflow) for observability.

Maximum string length: 256
parallel_tool_calls
boolean
previous_response_id
string
reasoning
object
service_tier
enum<string>
Available options:
standard,
priority,
flex,
batch
store
boolean
stream
boolean
temperature
number
Required range: 0 <= x <= 2
text
object
tool_choice

Tool selection strategy. gateway:datetime, gateway:web_search, and gateway:web_fetch are accepted and rewritten by the gateway into upstream function/tool targets.

Available options:
auto,
none,
required,
gateway:datetime,
gateway:web_search,
gateway:web_fetch
tools
object[]

Tool definitions for model function calls and gateway server tools. Built-in gateway server tools are gateway:datetime, gateway:web_search, and gateway:web_fetch.

top_p
number
Required range: 0 <= x <= 1
truncation
enum<string>
Available options:
auto,
disabled
user
string
prompt_cache_key
string | null
safety_identifier
string | null
modalities
enum<string>[]
Available options:
text,
image,
audio
image_config
object
provider_options
object

Optional provider-specific options.

usage
boolean
meta
boolean
echo_upstream_request
boolean
debug
object

Gateway debug controls. These flags are never forwarded upstream.

provider
object

Provider routing preferences for gateway selection.

Response

200 - application/json

Response

id
string
object
string
created
integer
model
string
output
object[]
output_items
object[]
content
object[]
role
string
stop_reason
string
type
string
usage
object
Last modified on July 9, 2026